# 쿠키

쿠키는 일종의 웹사이트에서 보여주는 증명서입니다.
이 증명서를 통해 웹사이트는 요청을 보내는 것이 어떤 사용자인지와 같은 정보를 파악할 수 있습니다.
따라서 웹툰을 열람하는 데에 로그인이 필요하다면, 쿠키를 복사해 앱에 붙여넣어 웹툰을 다운로드할 수 있습니다.

모든 플랫폼에서 쿠키가 필요한 것은 아닙니다.
대표적으로 네이버 웹툰의 경우 성인 웹툰이 아니면 다운로드에 쿠키를 필요로 하지 않습니다.

다음은 쿠키가 필요한 플랫폼들만 정리한 표입니다.
여기에 나와 있는 플랫폼들은 특정한 경우에 쿠키를 요구합니다.

| 플랫폼 | 필요 여부 | 비고 |
|--|--|--|
| 네이어 웹툰 | 성인 웹툰의 경우 필요 | |
| 레진코믹스 | 성인 웹툰의 경우 필요 | 특별히 쿠키 외에 bearer가 요구됩니다. [이 내용](platforms.md#bearer)을 참고하세요 |
| 버프툰 | 필요 | |
| 카카오 웹툰 | 성인 웹툰과 대여 및 구매한 웹툰의 경우 필요 | |
| 투믹스 | 필요 | |

## 쿠키 얻기

쿠키를 얻는 방법은 다음과 같습니다.

1. 원하는 **웹툰 플랫폼으로 가서 로그인**하세요.
1. **`f12`를 누르고** `ctrl+R`을 눌러 **새로고침**하세요.
1. `Network` 혹은 `네트워크` 탭으로 가서 제일 **처음에 있는 요청**을 누르세요.
1. 아래로 스크롤에서 `request header` 혹은 `요청 헤더`를 찾은 뒤 그 아래에 **`Cookie:`라고 되어 있는 부분을 찾으세요**.
1. 모든 내용을 복사하세요. 해당 내용을 아래의 '쿠키 입력' 파트의 내용대로 붙여넣으면 됩니다.

## 쿠키 입력

### 앱

앱에서 쿠키는 맨 아래의 [플랫폼 추가 설정]란에서 입력할 수 있습니다.

![cookie inserted](image/app-guide/1727108032165.png)

### 포터블, 패키지

포터블에서는 다운로드 시 `--cookie` 파라미터를 통해 쿠키를 입력할 수 있습니다.
쿠키 문자열은 일반적으로 상당히 길기 때문에 압도될 수 있지만, 그렇더라도 큰따옴표만 잘 붙이면 문제 없이 다운로드할 수 있습니다.

```console
webtoon download "<url>" --cookie "<cookie>"
```
